org.eclipse.cdt.core

## Interface ICDescriptor

Deprecated.
as this API is not configuration aware. Replaced by `ICConfigurationDescription` which can be fetched with `ICProjectDescription.getConfigurations()`

    @Deprecated
    public interface ICDescriptor

Restriction:
  This interface is not intended to be referenced by clients.

### Method Summary

All Methods Instance Methods Abstract Methods Deprecated Methods
`ICExtensionReference` `create(String extensionPointID, String id)` Deprecated. Use `ICConfigurationDescription.create(String, String)`
`ICExtensionReference[]` `get(String extensionPointID)` Deprecated. Use `ICConfigurationDescription.get(String)`
`ICExtensionReference[]` `get(String extensionPointID, boolean update)` Deprecated.
`ICConfigurationDescription` `getConfigurationDescription()` Deprecated. Returns the current settings configuration (which contains this descriptor) -- currently equivalent to `ICProjectDescription.getDefaultSettingConfiguration()`
`String` `getPlatform()` Deprecated.
`org.eclipse.core.resources.IProject` `getProject()` Deprecated.
`Element` `getProjectData(String id)` Deprecated. Use `getProjectStorageElement(String)`
`ICOwnerInfo` `getProjectOwner()` Deprecated.
`ICStorageElement` `getProjectStorageElement(String id)` Deprecated. Return a storage element corresponding to the id in which client related metadata may be stored.
`void` `remove(ICExtensionReference extension)` Deprecated. Use `ICConfigurationDescription.remove(org.eclipse.cdt.core.settings.model.ICConfigExtensionReference)`
`void` `remove(String extensionPoint)` Deprecated. Use `ICConfigurationDescription.remove(String)`
`ICStorageElement` `removeProjectStorageElement(String id)` Deprecated. Remove the storage element with the given ID from the tree
`void` `saveProjectData()` Deprecated. Saves any changes made to `ICStorageElement` objects obtained from `getProjectStorageElement(String)` to a CDT defined project meta-data file.

### Method Detail

#### getProjectOwner

    ICOwnerInfo getProjectOwner()

Deprecated.

#### getPlatform

    String getPlatform()

Deprecated.

#### getProject

    org.eclipse.core.resources.IProject getProject()

Deprecated.

Returns:
  the associated project

#### get

    @Deprecated
    ICExtensionReference[] get(String extensionPointID)

Deprecated. Use `ICConfigurationDescription.get(String)`
Returns an `ICExtensionReference`[] corresponding to a particular extensionPoint. This array contains all the ICExtensionReferences from all the ICConfigurationDescriptions in the project

Parameters:
  `extensionPointID` - String extensionPointID
Returns:
  ICExtensionReference[] ICExtensionReference array

#### get

    @Deprecated
    ICExtensionReference[] get(String extensionPointID,
                                           boolean update)
                                    throws org.eclipse.core.runtime.CoreException

Deprecated.
Returns an `ICExtensionReference`[] corresponding to a particular extensionPoint. This array contains all the ICExtensionReferences from all the ICConfigurationDescriptions in the project

Parameters:
  `extensionPointID` - String extensionPointID
  `update` - updates the COwner
Returns:
  ICExtensionReference[] ICExtensionReference array
Throws:
  `org.eclipse.core.runtime.CoreException`

#### create

    @Deprecated
    ICExtensionReference create(String extensionPointID,
                                            String id)
                                     throws org.eclipse.core.runtime.CoreException

Deprecated. Use `ICConfigurationDescription.create(String, String)`
Create an ICExtensionReference for the given extensionPointId with id = id. This is not CConfigurationDescription aware and so is added to all configurations in the project. You should instead use: `ICConfigurationDescription.create(String, String)`

Parameters:
  `extensionPointID` -
  `id` -
Returns:
  the create ICExtensionReference
Throws:
  `org.eclipse.core.runtime.CoreException`

#### remove

    @Deprecated
    void remove(ICExtensionReference extension)
                     throws org.eclipse.core.runtime.CoreException

Deprecated. Use `ICConfigurationDescription.remove(org.eclipse.cdt.core.settings.model.ICConfigExtensionReference)`
Remove a given ICExtensionReference from the project description.

Parameters:
  `extension` -
Throws:
  `org.eclipse.core.runtime.CoreException`

#### remove

    @Deprecated
    void remove(String extensionPoint)
                     throws org.eclipse.core.runtime.CoreException

Deprecated. Use `ICConfigurationDescription.remove(String)`
Remove ICExtensionReferences with the given extensionPoint from this descriptor

Parameters:
  `extensionPoint` -
Throws:
  `org.eclipse.core.runtime.CoreException`

#### getProjectStorageElement

    ICStorageElement getProjectStorageElement(String id)
                                       throws org.eclipse.core.runtime.CoreException

Deprecated.
Return a storage element corresponding to the id in which client related metadata may be stored.

Parameters:
  `id` - an identifier that uniquely identifies the client
Returns:
  a non-null `ICStorageElement` to which client specific meta-data may be attached
Throws:
  `org.eclipse.core.runtime.CoreException`
Since:
  5.1

#### getProjectData

    @Deprecated
    Element getProjectData(String id)
                                throws org.eclipse.core.runtime.CoreException

Deprecated. Use `getProjectStorageElement(String)`
This method has been superceded by `getProjectStorageElement(String)`

Parameters:
  `id` - an identifier that uniquely identifies the client
Returns:
  a non-null `Element` to which client specific meta-data may be attached
Throws:
  `org.eclipse.core.runtime.CoreException`
Restriction:
  This method is not intended to be referenced by clients.

#### removeProjectStorageElement

    ICStorageElement removeProjectStorageElement(String id)
                                          throws org.eclipse.core.runtime.CoreException

Deprecated.
Remove the storage element with the given ID from the tree

Parameters:
  `id` -
Returns:
  the ICStorageElement removed or null if there was none for id
Throws:
  `org.eclipse.core.runtime.CoreException`
Since:
  5.1

#### saveProjectData

    void saveProjectData()
                  throws org.eclipse.core.runtime.CoreException

Deprecated.
Saves any changes made to `ICStorageElement` objects obtained from `getProjectStorageElement(String)` to a CDT defined project meta-data file.

Throws:
  `org.eclipse.core.runtime.CoreException`

#### getConfigurationDescription

    ICConfigurationDescription getConfigurationDescription()

Deprecated.
Returns the current settings configuration (which contains this descriptor) -- currently equivalent to `ICProjectDescription.getDefaultSettingConfiguration()`

Returns:
  the current setting `ICConfigurationDescription`